////////////////////////////////////////////////////////////////////
// 
// Copyright (C) Decision Computer International Co., Ltd 
//
// # Project Name: PCI 14-Bit AD/DA Card VC++ 6.0 Sample (DII)
//
// # Used Library: Dynamice Industrial Interface
//
// # Designer: WeiCheng, Tu         2004/06/18
//
////////////////////////////////////////////////////////////////////

// Test14ADDADlg.cpp : implementation file
//

#include "stdafx.h"
#include "Test14ADDA.h"
#include "Test14ADDADlg.h"
#include "Dii.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTest14ADDADlg dialog

CTest14ADDADlg::CTest14ADDADlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest14ADDADlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTest14ADDADlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTest14ADDADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTest14ADDADlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control (pDX, IDC_COMBO1, inputChl);
	DDX_Control (pDX, IDC_COMBO2, outputChl);
	DDX_Control (pDX, IDC_COMBO3, ADchip);
	DDX_Control (pDX, IDC_BUTTON1, showDIO);
	DDX_Control (pDX, IDC_BUTTON3, startTestBtn);
	DDX_Control (pDX, IDC_BUTTON2, showOutput);
	DDX_Control (pDX, IDC_BUTTON4, showInput);
	DDX_Control (pDX, IDC_BUTTON7, showDiff);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTest14ADDADlg, CDialog)
	//{{AFX_MSG_MAP(CTest14ADDADlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON5, OnClearDIO)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON6, OnOK)
	ON_BN_CLICKED(IDC_BUTTON3, OnADDATest)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_CHECK1,IDC_CHECK16,DIOtest)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest14ADDADlg message handlers

BOOL CTest14ADDADlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//
	// select device
	//
    char szDeviceName[101];
	if (!DiiSelectDevice(NULL, szDeviceName,100))
	{
		AfxMessageBox ("Get device name Error!");
		return FALSE;
	}

	//
	// open user choosen device
	//
	hDevice = DiiOpenNamedDevice (szDeviceName, TRUE);
	if (hDevice ==INVALID_HANDLE_VALUE)
	{
		AfxMessageBox ("Open device Error!");
		return FALSE;
	}

	//
	// some initialization
	//
	outputChl.SetCurSel(0);
	inputChl.SetCurSel(0);
	ADchip.SetCurSel(0);
	DIOValue = 0;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTest14ADDADlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CTest14ADDADlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//
// exit the program
//
void CTest14ADDADlg::OnOK() 
{
	DiiCloseDevice(hDevice);
	KillTimer (addaTimer);
	exit(0);		
}

//
// some initializations to start ADDA test
//
void CTest14ADDADlg::OnADDATest() 
{
	DAValue = (1<<14) - 1;     // set initial DA Value (4095)          
	startTestBtn.SetWindowText ("Testing ...");
	startTestBtn.EnableWindow (FALSE);
	inputChl.EnableWindow (FALSE);
	outputChl.EnableWindow (FALSE);
	ADchip.EnableWindow (FALSE);
	addaTimer = SetTimer (1, 1, 0);
}

void CTest14ADDADlg::OnTimer(UINT nIDEvent) 
{
	unsigned short ADValue;    // input AD value
	double outVolt, inVolt;
	CString str;

	//
	// DAValue > 16383 (unsigned) ==> DAValue < 0 (signed)
	//
	if (DAValue > 16383)
		DAValue = 0;

	// output to DA channel and show result
	//outport (ioport + 2 + outputChl.GetCurSel() * 2, DAValue);
	DiiSetAnalogChannel (hDevice, outputChl.GetCurSel(), DAValue);

	//
	// Conversion
	//
	//ADDAConfig = inputChl.GetCurSel() | ADC_SCALE | ADC_TRIG_INT | ADC_SAMPLE;  // setting
	//outport (ioport, ADDAConfig);
	//ADDAConfig &= ADC_HOLD;          // hold
	//outport (ioport, ADDAConfig);
	//ADDAConfig |= ADC_TRIG;          // start conversion
	//outport (ioport, ADDAConfig);

	// delay
	//for (int cnt1 = 0; cnt1 <= 1000; cnt1 ++)
	//	for (int cnt2 = 0; cnt2 <= 1000; cnt2 ++) ;

	//
	//  input from AD
	//
	//ADDAConfig &= (~ADC_TRIG);
	//outport (ioport, ADDAConfig);
	//ADValue = inport (ioport + 0);
	DiiGetAnalogChannel (hDevice, inputChl.GetCurSel(), (unsigned long*)&ADValue);
	ADValue &= 0x3fff;

	//
	// show the result
	//
	outVolt = DA_Value (DAValue);
	inVolt = AD_Value (ADValue);
	str.Format ("%d                        %3.5lf   ", DAValue, outVolt);
	showOutput.SetWindowText (str);
	str.Format ("%d                        %3.5lf   ", ADValue, inVolt);
	showInput.SetWindowText (str);
	str.Format ("%3.5lf", inVolt - outVolt);
	showDiff.SetWindowText (str);

	//
	// Test finish
	//
	if (DAValue == 0)
	{
		startTestBtn.SetWindowText ("Start AD/DA Test");
		startTestBtn.EnableWindow (TRUE);
		inputChl.EnableWindow (TRUE);
		outputChl.EnableWindow (TRUE);
		ADchip.EnableWindow (TRUE);
		KillTimer (addaTimer);
	}

	DAValue -= 5;
	
	CDialog::OnTimer(nIDEvent);
}

//
// DA output digital value --> real analog voltage
//
double CTest14ADDADlg::DA_Value (USHORT DAData)
{
	double outVolt;     // mapped output voltage

	switch (ADchip.GetCurSel())
	{
		case 0:   // unipolar
		case 1:
		case 4:
			outVolt = (20.0 / 16384) * (DAData - 8192);
			break;

		case 2:   // bipolar
		case 3:
			outVolt = (10.0 / 16384) * DAData;

		default: break;
	}

	return outVolt;
}

//
// AD input digital value --> real analog voltage
//
double CTest14ADDADlg::AD_Value(USHORT ADData)
{
	double inVolt;    // mapped input voltage

	switch (ADchip.GetCurSel())
	{
		case 0:   // AD7899AR-1 (-10V ~ 10V)
			if ((ADData <= 16383) && (ADData >= 8192))
				inVolt = (20.0 / 16384) * (ADData - 16384);
			else
				inVolt = (20.0 / 16384) * ADData;
			break;

		case 1:   // AD7899AR-1 (-5V ~ 5V)
			if ((ADData <= 16383) && (ADData >= 8192))
				inVolt = (10.0 / 16384) * (ADData - 16384);
			else
				inVolt = (10.0 / 16384) * ADData;
			break;

		case 2:   // AD7899AR-2 (0V ~ 5V)
			inVolt = (5.0 / 16384) * ADData;
			break;

		case 3:   // AD7899AR-2 (0V ~ 2.5V)
			inVolt = (2.5 / 16384) * ADData;
			break;

		case 4:   // AD7899-3 (-2.5V ~ 2.5V)
			if ((ADData <= 16383) && (ADData >= 8192))
				inVolt = ((5.0/16384) * (ADData - 16384));
			else
				inVolt = ((5.0/16384) * ADData);
		default:
			break;
	}

	return inVolt;
}

//
// clear digital I/O port and show result
//
void CTest14ADDADlg::OnClearDIO() 
{
	DIOValue = 0;
	DiiSetDigitalWord (hDevice, 0, 0);

	for (int cnt = 0; cnt <= 15; cnt ++)
		CheckDlgButton (IDC_CHECK1 + cnt, BST_UNCHECKED);

	CString str;
	str.Format ("  0  ( 0 x 0 )");
	showDIO.SetWindowText (str);	
}

//
// handle digital I/O
//
void CTest14ADDADlg::DIOtest (UINT idButton)
{
	BOOL state = IsDlgButtonChecked(idButton);
	unsigned short wbit = idButton - IDC_CHECK1;
	unsigned short changedValue;                  // current output value

	//
	// form the digital value to output
	//
	changedValue = 1 << wbit;
	if(state)
		DIOValue |= changedValue;
	else
	{
		changedValue = ~changedValue;
		DIOValue &= changedValue;
	}

	//
	// output and show result
	//
	DiiSetDigitalWord (hDevice, 0, DIOValue);
	CString str;
	str.Format ("  %d  ( 0x%X )", DIOValue, DIOValue);
	showDIO.SetWindowText (str);
}


